import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;

public class Main {

  public static void main(String[] args) throws Exception {
    Connection conn = getMySqlConnection();
    System.out.println("Got Connection.");

    ResultSet rsColumns = null;
    DatabaseMetaData meta = conn.getMetaData();
    rsColumns = meta.getColumns(null, "%", "code", "%");
    
    while (rsColumns.next()) {
      String columnType = rsColumns.getString("TYPE_NAME");
      String columnName = rsColumns.getString("COLUMN_NAME");
      int size = rsColumns.getInt("COLUMN_SIZE");
      int nullable = rsColumns.getInt("NULLABLE");
      int position = rsColumns.getInt("ORDINAL_POSITION");

      System.out.println("column name=" + columnName);
      System.out.println("type=" + columnType);
      System.out.println("size=" + size);
      if (nullable == DatabaseMetaData.columnNullable) {
        System.out.println("nullable is true");
      } else {
        System.out.println("nullable is false");
      }
      System.out.println("position" + position);
    }

    conn.close();
  }

  private static Connection getHSQLConnection() throws Exception {
    Class.forName("org.hsqldb.jdbcDriver");
    System.out.println("Driver Loaded.");
    String url = "jdbc:hsqldb:data/tutorial";
    return DriverManager.getConnection(url, "sa", "");
  }

  public static Connection getMySqlConnection() throws Exception {
    String driver = "org.gjt.mm.mysql.Driver";
    String url = "jdbc:mysql://localhost/demo2s";
    String username = "oost";
    String password = "oost";

    Class.forName(driver); 
    Connection conn = DriverManager.getConnection(url, username, password);
    return conn;
  }

  public static Connection getOracleConnection() throws Exception {
    String driver = "oracle.jdbc.driver.OracleDriver";
    String url = "jdbc:oracle:thin:@localhost:1521:caspian";
    String username = "mp";
    String password = "mp2";

    Class.forName(driver); // load Oracle driver
    Connection conn = DriverManager.getConnection(url, username, password);
    return conn;
  }

}
